Перейти к основному содержимому

Интеграция с Angular

Подсказка

Чтобы использовать эту документацию, вы должны быть знакомы с основными концепциями и шаблонами Angular. Чтобы освежить знания, обратитесь к документации Angular.

DHTMLX Diagram Editor совместим с Angular. Мы подготовили примеры кода, показывающие, как использовать DHTMLX Diagram Editor с Angular. Дополнительную информацию можно найти в соответствующем примере на GitHub.

Создание проекта​

К сведению

Прежде чем создавать новый проект, установите Angular CLI и Node.js.

Создайте новый проект my-angular-diagram-app с помощью Angular CLI. Для этого выполните следующую команду:

ng new my-angular-diagram-app
Примечание

Если вы хотите следовать этому руководству, отключите серверный рендеринг (SSR) и статическую генерацию сайта (SSG/Prerendering) при создании нового приложения Angular!

Приведённая выше команда устанавливает все необходимые инструменты, поэтому вам не нужно выполнять дополнительные команды.

Установка зависимостей​

После этого перейдите в каталог приложения:

cd my-angular-diagram-app

Установите зависимости и запустите сервер разработки. Для этого используйте менеджер пакетов yarn:

yarn
yarn start

Приложение должно запуститься на локальном хосте (например, http://localhost:3000).

Создание Diagram Editor​

Теперь вам нужно получить исходный код DHTMLX Diagram Editor. Сначала остановите приложение и переходите к установке пакета Diagram Editor.

Шаг 1. Установка пакета​

Скачайте пробный пакет Diagram и выполните шаги, описанные в файле README. Обратите внимание, что пробная версия Diagram Editor доступна только в течение 30 дней.

Шаг 2. Создание компонента​

Теперь вам нужно создать компонент Angular, чтобы добавить Diagram Editor в приложение. Создайте папку diagram-editor в каталоге src/app/, добавьте в неё новый файл и назовите его diagram-editor.component.ts. Затем выполните шаги, описанные ниже.

Импорт исходных файлов​

Откройте файл и импортируйте исходные файлы Diagram Editor. Обратите внимание:

  • если вы используете PRO-версию и устанавливаете пакет Diagram Editor из локальной папки, путь импорта выглядит следующим образом:
import { DiagramEditor } from 'dhx-diagram-package';
  • если вы используете пробную версию Diagram, укажите следующий путь:
import { DiagramEditor } from '@dhx/trial-diagram';

В этом руководстве показано, как настроить пробную версию Diagram.

Настройка контейнера и инициализация Diagram Editor​

Чтобы отобразить Diagram Editor на странице, нужно задать контейнер, внутри которого будет отрисовываться компонент, и инициализировать Diagram Editor с помощью соответствующего конструктора:

diagram-editor.component.ts
import { DiagramEditor } from "@dhx/trial-diagram";
import { IDefaultEditorConfig } from "@dhx/trial-diagram/codebase/types/ts-diagram-editor";
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: 'diagram-editor', // имя шаблона, используемое в файле "app.component.ts" как <diagram-editor/>
styleUrls: ['./diagram-editor.component.css'], // подключение файла css
template: `<div #container class = "widget"></div>`
})

export class DiagramEditorComponent implements OnInit, OnDestroy {
// инициализация контейнера для Diagram Editor
@ViewChild('container', { static: true }) editor_container!: ElementRef;

private _diagram_editor!: DiagramEditor;

ngOnInit() {
// инициализация компонента Diagram Editor
this._diagram_editor = new DiagramEditor( this.editor_container.nativeElement, { type: "default" } as IDefaultEditorConfig);
}

ngOnDestroy() {
this._diagram_editor.destructor(); // уничтожение Diagram Editor
}
}

Добавление стилей​

Чтобы Diagram Editor отображался корректно, нужно указать соответствующие стили. Для этого можно создать файл diagram-editor.component.css в каталоге src/app/diagram-editor/ и задать важные стили для Diagram Editor и его контейнера:

diagram-editor.component.css
/* импорт стилей Diagram Editor */
@import "@dhx/trial-diagram/codebase/diagram.min.css";

/* стили для начальной страницы */
html,
body {
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Diagram Editor */
.widget {
height: 100%;
width: 100%;
}

Загрузка данных​

Чтобы добавить данные в Diagram Editor, нужно предоставить набор данных. Вы можете создать файл data.ts в каталоге src/app/diagram-editor/ и добавить в него данные:

data.ts
export function getData() {
return [
{ id: 1, x: 880, y: 105, text: "Does user remember his password?", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 2, x: 1080, y: 125, width: 50, "height": 50, text: "XOR", type: "circle", lineHeight: 18, fontColor: "#fff", fill: "#7D8495", stroke: "#7D8495" },
{ id: 3, x: 1160, y: 40, text: "User forgets his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 3.1, x: 1340, y: 40, text: "Send an E-mail with new password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 3.2, x: 1520, y: 40, text: "E-mail sent", type: "preparation", fontColor: "#fff", lineHeight: 18, fill: "#33B579", stroke: "#33B579" },
{ id: 4, x: 1160, y: 180, text: "User remembers his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 5, x: 1340, y: 180, text: "User types in login and password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
// другие данные

{ from: 1, to: 2, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3, type: "dash", toSide: "bottom", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 7.5, type: "dash", fromSide: "bottom", toSide: "top", backArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3.2, type: "dash", fromSide: "top", toSide: "top", stroke: "#7D8495" },
{ from: 3, to: 3.1, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 3.1, to: 3.2, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 4, type: "dash", toSide: "top", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 4, to: 5, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 5, to: 6, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
// другие данные
]
}

Затем откройте файл diagram-editor.component.ts. Импортируйте файл с данными и примените их с помощью метода parse() внутри метода ngOnInit(), как показано ниже.

diagram-editor.component.ts
import { DiagramEditor } from "@dhx/trial-diagram";
import { IDefaultEditorConfig } from "@dhx/trial-diagram/codebase/types/ts-diagram-editor";
import { getData } from "./data"; // импорт данных
import { Component, ElementRef, OnInit, ViewChild, OnDestroy, ViewEncapsulation } from '@angular/core';

@Component({
encapsulation: ViewEncapsulation.None,
selector: 'diagram-editor',
styleUrls: ['./diagram-editor.component.css'],
template: `<div #container class = "widget"></div>`
})

export class DiagramEditorComponent implements OnInit, OnDestroy {
@ViewChild('container', { static: true }) editor_container!: ElementRef;

private _diagram_editor!: DiagramEditor;

ngOnInit() {
const data = getData(); // инициализация свойства data
this._diagram_editor = new DiagramEditor( this.editor_container.nativeElement, { type: "default" } as IDefaultEditorConfig);

this._diagram_editor.parse(data);
}

ngOnDestroy() {
this._diagram_editor.destructor();
}
}

Теперь компонент Diagram Editor готов к использованию. Когда элемент будет добавлен на страницу, он инициализирует Diagram Editor с данными. Вы также можете указать необходимые настройки конфигурации. Посетите наш справочник API Diagram Editor, чтобы ознакомиться с полным списком доступных свойств.

Обработка событий​

Когда пользователь выполняет какое-либо действие в Diagram Editor, возникает событие. Вы можете использовать эти события, чтобы отслеживать действие и запускать нужный код в ответ на него. См. полный список событий.

Откройте файл diagram-editor.component.ts и дополните метод ngOnInit() следующим образом:

diagram-editor.component.ts
// ...
ngOnInit() {
this._diagram_editor = new DiagramEditor(this.editor_container.nativeElement, { type: "default" } as IDefaultEditorConfig);

this._diagram_editor.events.on("zoomIn", (step) => {
console.log("The diagram in the editor is zoomed in. The step is" + step);
});
}

ngOnDestroy() {
this._diagram_editor.destructor();
}

Шаг 3. Добавление Diagram Editor в приложение​

Чтобы добавить DiagramEditorComponent в приложение, откройте файл src/app/app.component.ts и замените код по умолчанию следующим:

app.component.ts
import { Component } from "@angular/core";

@Component({
selector: "app-root",
template: `<diagram-editor/>` // шаблон, созданный в файле "diagram-editor.component.ts"
})
export class AppComponent {
name = "";
}

Затем создайте файл app.module.ts в каталоге src/app/ и укажите DiagramEditorComponent, как показано ниже:

app.module.ts
import { NgModule } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";

import { AppComponent } from "./app.component";
import { DiagramEditorComponent } from "./diagram-editor/diagram-editor.component";

@NgModule({
declarations: [AppComponent, DiagramEditorComponent],
imports: [BrowserModule],
bootstrap: [AppComponent]
})
export class AppModule {}

Последний шаг — открыть файл src/main.ts и заменить существующий код следующим:

main.ts
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { AppModule } from "./app/app.module";
platformBrowserDynamic()
.bootstrapModule(AppModule)
.catch((err) => console.error(err));

После этого вы можете запустить приложение и увидеть Diagram Editor, загруженный с данными на странице.

Инициализация Diagram Editor

Теперь вы знаете, как интегрировать DHTMLX Diagram Editor с Angular. Вы можете настроить код в соответствии со своими требованиями. Итоговый пример можно найти на GitHub.

Перейти к основному содержимому

Интеграция с Vue

Подсказка

Прежде чем читать эту документацию, вам следует ознакомиться с базовыми концепциями и паттернами Vue. Чтобы освежить знания, обратитесь к документации Vue 3.

DHTMLX Diagram Editor совместим с Vue. Мы подготовили примеры кода по использованию DHTMLX Diagram Editor с Vue 3. Подробнее см. соответствующий Пример на GitHub.

Создание проекта​

К сведению

Прежде чем приступить к созданию нового проекта, установите Node.js.

Чтобы создать проект Vue, выполните следующую команду:

npm create vue@latest

Эта команда устанавливает и запускает create-vue — официальный инструмент для скаффолдинга проектов Vue. Подробности см. в разделе Vue.js. Быстрый старт.

Назовём проект my-vue-diagram-app.

Установка зависимостей​

Перейдите в директорию приложения:

cd my-vue-diagram-app

Установите зависимости и запустите сервер разработки. Для этого используйте менеджер пакетов:

  • если вы используете yarn, выполните следующие команды:
yarn
yarn start // или yarn dev
  • если вы используете npm, выполните следующие команды:
npm install
npm run dev

Приложение должно запуститься на localhost (например, http://localhost:3000).

Создание Diagram Editor​

Теперь необходимо получить исходный код DHTMLX Diagram Editor. Сначала остановите приложение и переходите к установке пакета Diagram Editor.

Шаг 1. Установка пакета​

Скачайте пробный пакет Diagram Editor и выполните шаги, описанные в файле README. Обратите внимание, что пробная версия Diagram Editor доступна только в течение 30 дней.

Шаг 2. Создание компонента​

Теперь необходимо создать компонент Vue, чтобы добавить Diagram Editor в приложение. Создайте новый файл в директории src/components/ и назовите его DiagramEditor.vue.

Импорт исходных файлов​

Откройте файл DiagramEditor.vue и импортируйте исходные файлы Diagram Editor. Обратите внимание:

  • если вы используете PRO-версию и устанавливаете пакет Diagram Editor из локальной папки, пути импорта будут выглядеть так:
DiagramEditor.vue
<script>
import { DiagramEditor } from 'dhx-diagram-package';
import 'dhx-diagram-package/codebase/diagram.css';
</script>

Обратите внимание, что в зависимости от используемого пакета исходные файлы могут быть минифицированы. В этом случае убедитесь, что вы импортируете CSS-файл как diagram.min.css.

  • если вы используете пробную версию Diagram Editor, укажите следующие пути:
DiagramEditor.vue
<script>
import { DiagramEditor } from '@dhx/trial-diagram';
import '@dhx/trial-diagram/codebase/diagram.min.css';
</script>

В этом руководстве показано, как настроить пробную версию Diagram Editor.

Настройка контейнера и инициализация Diagram Editor​

Чтобы отобразить Diagram Editor на странице, необходимо создать контейнер для Diagram Editor и инициализировать этот компонент с помощью соответствующего конструктора:

DiagramEditor.vue
<script>
import { DiagramEditor } from "@dhx/trial-diagram";
import "@dhx/trial-diagram/codebase/diagram.min.css";

export default {
mounted() {
// инициализация компонента Diagram Editor
this.diagram_editor = new DiagramEditor(this.$refs.container, { type: "default" });
},

unmounted() {
this.diagram_editor.destructor(); // уничтожение Diagram Editor
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Добавление стилей​

Чтобы Diagram Editor отображался корректно, необходимо задать важные стили для Diagram Editor и его контейнера в CSS-файле проекта:

style.css
/* задайте стили для начальной страницы */
html,
body,
#root { /* убедитесь, что используете контейнер #root */
height: 100%;
padding: 0;
margin: 0;
}

/* задайте стили для контейнера Diagram Editor */
.widget {
height: 100%;
width: 100%;
}

Загрузка данных​

Чтобы добавить данные в Diagram Editor, необходимо предоставить набор данных. Вы можете создать файл data.js в директории src/ и добавить в него данные:

data.js
export function getData() {
return [
{ id: 1, x: 880, y: 105, text: "Does user remember his password?", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 2, x: 1080, y: 125, width: 50, "height": 50, text: "XOR", type: "circle", lineHeight: 18, fontColor: "#fff", fill: "#7D8495", stroke: "#7D8495" },
{ id: 3, x: 1160, y: 40, text: "User forgets his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 3.1, x: 1340, y: 40, text: "Send an E-mail with new password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 3.2, x: 1520, y: 40, text: "E-mail sent", type: "preparation", fontColor: "#fff", lineHeight: 18, fill: "#33B579", stroke: "#33B579" },
{ id: 4, x: 1160, y: 180, text: "User remembers his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 5, x: 1340, y: 180, text: "User types in login and password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
// другие данные

{ from: 1, to: 2, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3, type: "dash", toSide: "bottom", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 7.5, type: "dash", fromSide: "bottom", toSide: "top", backArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3.2, type: "dash", fromSide: "top", toSide: "top", stroke: "#7D8495" },
{ from: 3, to: 3.1, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 3.1, to: 3.2, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 4, type: "dash", toSide: "top", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 4, to: 5, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 5, to: 6, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
// другие данные
]
}

Затем откройте файл App.vue, импортируйте данные и инициализируйте их с помощью внутреннего метода data(). После этого вы можете передать данные во вновь созданный компонент <DiagramEditor/> как props:

App.vue
<script>
import DiagramEditor from "./components/DiagramEditor.vue";
import { getData } from "./data";

export default {
components: { DiagramEditor },
data() {
return { data: getData() };
}
};
</script>

<template>
<DiagramEditor :data="data" />
</template>

Перейдите в файл DiagramEditor.vue и примените переданные props к Diagram Editor с помощью метода parse():

DiagramEditor.vue
<script>
import { DiagramEditor } from "@dhx/trial-diagram";
import "@dhx/trial-diagram/codebase/diagram.min.css";

export default {
props: ["data"],

mounted() {
this.diagram_editor = new DiagramEditor(this.$refs.container, { type: "default" });
this.diagram_editor.parse(this.data);
},

unmounted() {
this.diagram_editor.destructor();
}
};
</script>

<template>
<div ref="container" class="widget"></div>
</template>

Теперь компонент Diagram Editor готов к использованию. При добавлении элемента на страницу он инициализирует Diagram Editor с данными. Вы также можете указать необходимые настройки конфигурации. Посетите наш раздел документация по API Diagram Editor, чтобы увидеть полный список доступных свойств.

Обработка событий​

Когда пользователь выполняет какое-либо действие в Diagram Editor, вызывается событие. Вы можете использовать эти события, чтобы отслеживать действия и выполнять нужный код. См. полный список событий.

Откройте DiagramEditor.vue и дополните метод mounted():

DiagramEditor.vue
<script>
// ...
export default {
// ...
mounted: function() {
this.diagram_editor = new DiagramEditor(this.$refs.container, { type: "default" });

this.diagram_editor.events.on("zoomIn", (step) => {
console.log("The diagram in the editor is zoomed in. The step is" + step);
});
}
//...
}
</script>

//...

После этого запустите приложение, чтобы увидеть Diagram Editor, загруженный данными, на странице.

Инициализация Diagram Editor

Теперь вы знаете, как интегрировать DHTMLX Diagram Editor с Vue. Вы можете настроить код в соответствии со своими требованиями. Итоговый пример можно найти на GitHub.

Перейти к основному содержимому

Интеграция с React

Подсказка

Чтобы использовать эту документацию, вы должны быть знакомы с основными концепциями и шаблонами React. Чтобы освежить знания, обратитесь к документации React.

DHTMLX Diagram Editor совместим с React. Мы подготовили примеры кода, показывающие, как использовать DHTMLX Diagram Editor с React. Дополнительную информацию можно найти в соответствующем примере на GitHub.

Создание проекта​

К сведению

Прежде чем создавать новый проект, установите Vite (необязательно) и Node.js.

Вы можете создать базовый проект React (используемый в этом руководстве) или использовать React с Vite. Назовём проект my-react-diagram-app:

npx create-react-app my-react-diagram-app

Установка зависимостей​

Перейдите в каталог только что созданного приложения:

cd my-react-diagram-app

Установите зависимости и запустите сервер разработки. Для этого используйте менеджер пакетов:

  • если вы используете yarn, выполните следующие команды:
yarn
yarn start
  • если вы используете npm, выполните следующие команды:
npm install
npm run dev

Приложение должно запуститься на локальном хосте (например, http://localhost:3000).

Создание Diagram Editor​

Теперь вам нужно получить исходный код DHTMLX Diagram Editor. Сначала остановите приложение и переходите к установке пакета Diagram Editor.

Шаг 1. Установка пакета​

Скачайте пробный пакет Diagram Editor и выполните шаги, описанные в файле README. Обратите внимание, что пробная версия Diagram Editor доступна только в течение 30 дней.

Шаг 2. Создание компонента​

Теперь вам нужно создать компонент React, чтобы добавить Diagram Editor в приложение. Создайте новый файл в каталоге src/ и назовите его DiagramEditor.jsx.

Импорт исходных файлов​

Откройте файл DiagramEditor.jsx и импортируйте исходные файлы Diagram Editor. Обратите внимание:

  • если вы используете PRO-версию и устанавливаете пакет Diagram Editor из локальной папки, пути импорта выглядят следующим образом:
DiagramEditor.jsx
import { DiagramEditor } from 'dhx-diagram-package';
import 'dhx-diagram-package/codebase/diagram.css';

Обратите внимание, что в зависимости от используемого пакета исходные файлы могут быть минифицированы. В этом случае убедитесь, что вы импортируете файл CSS как diagram.min.css.

  • если вы используете пробную версию Diagram, укажите следующие пути:
DiagramEditor.jsx
import { DiagramEditor } from '@dhx/trial-diagram';
import '@dhx/trial-diagram/codebase/diagram.min.css';

В этом руководстве показано, как настроить пробную версию Diagram.

Настройка контейнера и инициализация Diagram Editor​

Чтобы отобразить Diagram Editor на странице, нужно создать контейнер для Diagram Editor и инициализировать этот компонент с помощью соответствующего конструктора:

DiagramEditor.jsx
import { useEffect, useRef } from "react";
import { DiagramEditor } from "@dhx/trial-diagram";
import "@dhx/trial-diagram/codebase/diagram.min.css"; // подключение стилей Diagram Editor

export default function DiagramEditorComponent(props) {
let container = useRef(); // инициализация контейнера для Diagram Editor

useEffect(() => {
// инициализация компонента Diagram Editor
const diagram_editor = new DiagramEditor(container.current, {});

return () => {
diagram_editor.destructor(); // уничтожение Diagram Editor
}
});

return <div ref={container} className="widget"></div>;
}

Добавление стилей​

Чтобы Diagram Editor отображался корректно, укажите важные стили для Diagram Editor и его контейнера в CSS-файле проекта:

index.css
/* стили для начальной страницы */
html,
body,
#root {
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Diagram Editor */
.widget {
height: 100%;
width: 100%;
}

Загрузка данных​

Чтобы добавить данные в Diagram Editor, нужно предоставить набор данных. Создадим файл data.js в каталоге src/ и добавим в него данные:

data.js
export function getData() {
return [
{ id: 1, x: 880, y: 105, text: "Does user remember his password?", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 2, x: 1080, y: 125, width: 50, "height": 50, text: "XOR", type: "circle", lineHeight: 18, fontColor: "#fff", fill: "#7D8495", stroke: "#7D8495" },
{ id: 3, x: 1160, y: 40, text: "User forgets his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 3.1, x: 1340, y: 40, text: "Send an E-mail with new password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 3.2, x: 1520, y: 40, text: "E-mail sent", type: "preparation", fontColor: "#fff", lineHeight: 18, fill: "#33B579", stroke: "#33B579" },
{ id: 4, x: 1160, y: 180, text: "User remembers his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 5, x: 1340, y: 180, text: "User types in login and password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
// другие данные

{ from: 1, to: 2, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3, type: "dash", toSide: "bottom", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 7.5, type: "dash", fromSide: "bottom", toSide: "top", backArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3.2, type: "dash", fromSide: "top", toSide: "top", stroke: "#7D8495" },
{ from: 3, to: 3.1, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 3.1, to: 3.2, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 4, type: "dash", toSide: "top", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 4, to: 5, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 5, to: 6, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
// другие данные
]
}

Затем откройте файл App.js и импортируйте данные. После этого вы можете передать данные в только что созданный компонент <DiagramEditor/> в качестве props:

App.js
import DiagramEditor from "./DiagramEditor";
import { getData } from "./data";

function App() {
let data = getData();
return <DiagramEditor data={data} />;
}

export default App;

Перейдите в файл DiagramEditor.jsx и примените переданные props к Diagram Editor с помощью метода parse():

DiagramEditor.jsx
import { useEffect, useRef } from "react";
import { DiagramEditor } from "@dhx/trial-diagram";
import "@dhx/trial-diagram/codebase/diagram.min.css";

export default function DiagramEditorComponent(props) {
let container = useRef();

useEffect(() => {
const diagram_editor = new DiagramEditor(container.current, {});

diagram_editor.parse(props.data);

return () => {
diagram_editor.destructor();
}
});

return <div ref={container} className="widget"></div>;
}

Теперь компонент Diagram Editor готов к использованию. Когда элемент будет добавлен на страницу, он инициализирует Diagram Editor с данными. Вы также можете указать необходимые настройки конфигурации. Посетите наш справочник API Diagram Editor, чтобы ознакомиться с полным списком доступных свойств.

Обработка событий​

Когда пользователь выполняет какое-либо действие в Diagram Editor, возникает событие. Вы можете использовать эти события, чтобы отслеживать действие и запускать нужный код в ответ на него. См. полный список событий.

Откройте DiagramEditor.jsx и дополните метод useEffect() следующим образом:

DiagramEditor.jsx
// ...
useEffect(() => {
const diagram_editor = new DiagramEditor(container.current, {});

diagram_editor.events.on("zoomIn", (step) => {
console.log("The diagram in the editor is zoomed in. The step is" + step);
});

return () => {
diagram_editor.destructor();
}
}, []);
// ...

После этого вы можете запустить приложение и увидеть Diagram Editor, загруженный с данными на странице.

Инициализация Diagram Editor

Теперь вы знаете, как интегрировать DHTMLX Diagram Editor с React. Вы можете настроить код в соответствии со своими требованиями. Итоговый пример можно найти на GitHub.

Перейти к основному содержимому

Интеграция с Svelte

Подсказка

Прежде чем читать эту документацию, вы должны быть знакомы с основными концепциями и шаблонами Svelte. Чтобы освежить знания, обратитесь к документации Svelte.

DHTMLX Diagram Editor совместим со Svelte. Мы подготовили примеры кода, показывающие, как использовать DHTMLX Diagram Editor со Svelte. Дополнительную информацию можно найти в соответствующем примере на GitHub.

Создание проекта​

К сведению

Прежде чем создавать новый проект, установите Vite (необязательно) и Node.js.

Чтобы создать проект Svelte на JS, выполните следующую команду:

npm create vite@latest

При создании проекта выберите варианты Svelte и JavaScript. Назовём проект my-svelte-diagram-app.

Установка зависимостей​

Перейдите в каталог приложения:

cd my-svelte-diagram-app

Затем вам нужно установить зависимости и запустить приложение. Для этого используйте менеджер пакетов:

  • если вы используете yarn, выполните следующие команды:
yarn
yarn start // или yarn dev
  • если вы используете npm, выполните следующие команды:
npm install
npm run dev

Приложение должно запуститься на локальном хосте (например, http://localhost:3000).

Создание Diagram Editor​

Теперь вам нужно получить исходный код DHTMLX Diagram Editor. Сначала остановите приложение и переходите к установке пакета Diagram Editor.

Шаг 1. Установка пакета​

Скачайте пробный пакет Diagram Editor и выполните шаги, описанные в файле README. Обратите внимание, что пробная версия Diagram Editor доступна только в течение 30 дней.

Шаг 2. Создание компонента​

Теперь вам нужно создать компонент Svelte, чтобы добавить Diagram Editor в приложение. Создадим новый файл в каталоге src/ и назовём его DiagramEditor.svelte.

Импорт исходных файлов​

Откройте файл DiagramEditor.svelte и импортируйте исходные файлы Diagram Editor. Обратите внимание:

  • если вы используете PRO-версию и устанавливаете пакет Diagram Editor из локальной папки, пути импорта выглядят следующим образом:
DiagramEditor.svelte
<script>
import { DiagramEditor } from 'dhx-diagram-package';
import 'dhx-diagram-package/codebase/diagram.css';
</script>

Обратите внимание, что в зависимости от используемого пакета исходные файлы могут быть минифицированы. В этом случае убедитесь, что вы импортируете файл CSS как diagram.min.css.

  • если вы используете пробную версию Diagram Editor, укажите следующие пути:
DiagramEditor.svelte
<script>
import { DiagramEditor } from '@dhx/trial-diagram';
import '@dhx/trial-diagram/codebase/diagram.min.css';
</script>

В этом руководстве показано, как настроить пробную версию Diagram Editor.

Настройка контейнера и инициализация Diagram Editor​

Чтобы отобразить Diagram Editor на странице, нужно создать контейнер для Diagram Editor и инициализировать этот компонент с помощью соответствующего конструктора:

DiagramEditor.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { DiagramEditor } from "@dhx/trial-diagram";
import "@dhx/trial-diagram/codebase/diagram.min.css"

let container; // инициализация контейнера для Diagram Editor
let diagram_editor;

onMount(() => {
// инициализация компонента Diagram Editor
diagram_editor = new DiagramEditor(container, {});
});

onDestroy(() => {
diagram_editor.destructor(); // уничтожение Diagram Editor
});
</script>

<div bind:this={container} class="widget"></div>

Добавление стилей​

Чтобы Diagram Editor отображался корректно, укажите важные стили для Diagram Editor и его контейнера в CSS-файле проекта:

app.css
/* стили для начальной страницы */
html,
body,
#app { /* убедитесь, что используете корневой контейнер #app */
height: 100%;
padding: 0;
margin: 0;
}

/* стили для контейнера Diagram Editor */
.widget {
height: 100%;
width: 100%;
}

Загрузка данных​

Чтобы добавить данные в Diagram Editor, нужно предоставить набор данных. Создадим файл data.js в каталоге src/ и добавим в него данные:

data.js
export function getData() {
return [
{ id: 1, x: 880, y: 105, text: "Does user remember his password?", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 2, x: 1080, y: 125, width: 50, "height": 50, text: "XOR", type: "circle", lineHeight: 18, fontColor: "#fff", fill: "#7D8495", stroke: "#7D8495" },
{ id: 3, x: 1160, y: 40, text: "User forgets his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 3.1, x: 1340, y: 40, text: "Send an E-mail with new password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
{ id: 3.2, x: 1520, y: 40, text: "E-mail sent", type: "preparation", fontColor: "#fff", lineHeight: 18, fill: "#33B579", stroke: "#33B579" },
{ id: 4, x: 1160, y: 180, text: "User remembers his password", type: "preparation", lineHeight: 18, fontColor: "#fff", fill: "#33B579", stroke: "#33B579" },
{ id: 5, x: 1340, y: 180, text: "User types in login and password", type: "process", lineHeight: 18, fontColor: "#fff", fill: "#3DA0E3", stroke: "#3DA0E3" },
// другие данные

{ from: 1, to: 2, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3, type: "dash", toSide: "bottom", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 7.5, type: "dash", fromSide: "bottom", toSide: "top", backArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 3.2, type: "dash", fromSide: "top", toSide: "top", stroke: "#7D8495" },
{ from: 3, to: 3.1, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 3.1, to: 3.2, type: "line", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 2, to: 4, type: "dash", toSide: "top", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 4, to: 5, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
{ from: 5, to: 6, type: "dash", forwardArrow: "filled", stroke: "#7D8495" },
// другие данные
]
}

Затем откройте файл App.svelte, импортируйте данные и передайте их в только что созданный компонент <DiagramEditor/> в качестве props:

App.svelte
<script>
import DiagramEditor from "./DiagramEditor.svelte";
import { getData } from "./data.js";

const data = getData();
</script>

<DiagramEditor data={data} />

Перейдите в файл DiagramEditor.svelte и примените переданные props к Diagram Editor с помощью метода parse():

DiagramEditor.svelte
<script>
import { onMount, onDestroy } from "svelte";
import { DiagramEditor } from "@dhx/trial-diagram";
import "@dhx/trial-diagram/codebase/diagram.min.css"

export let data;

let container;
let diagram_editor;

onMount(() => {
diagram_editor = new DiagramEditor(container, {});
diagram_editor.parse(data);
});

onDestroy(() => {
diagram_editor.destructor();
});
</script>

<div bind:this={container} class="widget"></div>

Теперь компонент Diagram Editor готов к использованию. Когда элемент будет добавлен на страницу, он инициализирует Diagram Editor с данными. Вы также можете указать необходимые настройки конфигурации. Посетите наш справочник API Diagram Editor, чтобы ознакомиться с полным списком доступных свойств.

Обработка событий​

Когда пользователь выполняет какое-либо действие в Diagram Editor, возникает событие. Вы можете использовать эти события, чтобы отслеживать действие и запускать нужный код в ответ на него. См. полный список событий.

Откройте DiagramEditor.svelte и дополните метод onMount() следующим образом:

DiagramEditor.svelte
<script>
// ...
let diagram_editor;

onMount(() => {
diagram_editor = new DiagramEditor(container, {})

diagram_editor.events.on("afterFocusSet", function(cell){
console.log("Focus is set on a cell " + diagram_editor.selection.getSelectedCell());
console.log(cell);
});
});

onDestroy(() => {
diagram_editor.destructor();
});
</script>

// ...

После этого, когда мы запустим приложение, мы должны увидеть Diagram Editor, загруженный с данными на странице.

Инициализация Diagram Editor

Теперь у вас должна быть базовая настройка для интеграции DHTMLX Diagram Editor со Svelte. Вы можете настроить код в соответствии со своими требованиями. Итоговый пример можно найти на GitHub.